using System;

namespace ConsoleApp5
{
    class Program
    {
        static void Main(string[] args)
        {
            int t = int.Parse(Console.ReadLine());
            int[] final = new int[t];
            int index = 0;
            for (int j = 0; j < t; j++)
            {
                Console.ReadLine();
                string[] s = Console.ReadLine().Split(' ');
                string[] g = Console.ReadLine().Split(' ');

                long razlika = Math.Abs(long.Parse(s[0]) - long.Parse(s[1]));
                bool failed = false;
                for (int i = 1; i < s.Length - 1; i++)
                {
                    long razlika2 = Math.Abs(long.Parse(s[i]) - long.Parse(s[i + 1]));
                    if (razlika > razlika2)
                    {
                        if (razlika % razlika2 == 0)
                        {
                            razlika = razlika2;
                        }
                        else
                        {
                            failed = true;
                            break;
                        }
                    }
                    else
                    {
                        if (razlika2 % razlika != 0)
                        {
                            failed = true;
                            break;
                        }
                    }
                }

                if(failed)
                {
                    final[index++] = 0;
                }
                else
                {
                    bool failed2 = false;
                    long delilac = razlika;
                    long ostatak = long.Parse(s[0]) % razlika;
                    for (int i = 0; i < g.Length; i++)
                        if (long.Parse(g[i]) % delilac == ostatak)
                        {
                            final[index++] = 0;
                            failed2 = true;
                            break;
                        }
                    if (!failed2)
                        final[index++] = 1;
                }
            }
            for (int i = 0; i < final.Length; i++)
                Console.WriteLine(final[i]);
        }
    }
}